<template>
  <q-page class="flex flex-center">
    <q-table
      :data="users"
      :columns="columns"
      :filter="filter"
      :visible-columns="visibleColumns"
      :separator="separator"
      row-key="user_id"
      ref="table"
      color="primary"
      title="Users"
      :pagination.sync="pagination"
      :loading="loadingTable"
      :rows-per-page-options="pagination.options"
      binary-state-sort
      @request="request"
    >
      <template v-slot:top="props">
        <span class="text-h5">
         Users
        </span>
        <q-btn class="q-ml-sm" label="Add New User" color="positive" @click="createNewUser" no-caps dense />
        <q-space/>
        <q-select
          v-model="visibleColumns"
          multiple
          borderless
          dense
          options-dense
          :display-value="$q.lang.table.columns"
          emit-value
          map-options
          :options="columns"
          option-value="name"
        />
        <q-select
          v-model="separator"
          emit-value
          map-options
          borderless
          dense
          :options="[
        { label: 'Horizontal (default)', value: 'horizontal' },
        { label: 'Vertical', value: 'vertical' },
        { label: 'Cell', value: 'cell' },
        { label: 'None', value: 'none' },
      ]"
        />
        <q-btn
          flat round dense
          :icon="props.inFullscreen ? 'fullscreen_exit' : 'fullscreen'"
          @click="props.toggleFullscreen"
        />
      </template>
      <q-td slot="body-cell-action" slot-scope="props" :props="props">
        <q-btn flat
               round
               rounded
               dense
               color="primary"
               icon="edit"
               @click="editUser(props.row.user_id)"
        >
        </q-btn>
        <q-btn flat
               round
               rounded
               dense
               color="negative"
               icon="delete"
               @click="deleteUser(props.row.user_id)"
        >
        </q-btn>
      </q-td>
    </q-table>
    <q-dialog v-model="userDialog" persistant>
      <user-detail :isEdit="userEditable" :id="userId" @userCreated="closeDialog" @userCanceled="closeDialog" @userUpdated="closeDialog"></user-detail>
    </q-dialog>
  </q-page>
</template>

<script>
  import moment from 'moment'
  import UserDetail from "../components/UserDetail";
export default {
  name: 'PageIndex',
  components:{
    UserDetail
  },
  data(){
    return{
      userId:null,
      userEditable:false,
      userDialog:false,
      users:[],
      user:{},
      loadingTable:false,
      filter:null,
      visibleColumns: ['full_name', 'email', 'username', 'creation_date', 'action'],
      separator: 'horizontal',
      columns: [
        {name: 'id', field: 'user_id', label: 'ID', sortable: true, align: 'left'},
        {name: 'full_name', field: 'full_name', label: 'Name', align: 'left', sortable: true},
        {name: 'email', field: 'email', label: 'Email', align: 'left'},
        {name: 'username', field: 'username', label: 'Username', align: 'left'},
        {name: 'creation_date',  field: (row) => moment(row.creation_date).fromNow(), label: 'Created At', align: 'left'},
        {name: 'action', field: 'action', label: 'Actions', align: 'left'},
      ],
    }
  },
  methods:{
    deleteUser(id){
      this.$q.dialog({
        title: 'Delete User',
        message: 'Are you sure to delete',
        cancel: true,
        persistent: true
      }).onOk(() => {
        this.$store.dispatch('users/deleteUser',id).then(()=>{
          this.request({pagination: this.pagination, filter: this.filter})
        })
      }).onCancel(() => {
        // console.log('Cancel')
      }).onDismiss(() => {
        // console.log('I am triggered on both OK and Cancel')
      })
    },
    closeDialog(val){
      if(val==true){
        this.userDialog=false;
        this.request({pagination: this.pagination, filter: this.filter})
      }
    },
    createNewUser(){
      this.userEditable=false;
      this.userDialog=true;
    },
    editUser(id){
      this.userId=id
      this.userEditable=true;
      this.userDialog=true;
    },
    request({pagination, filter}) {
      this.loadingTable = true
      return new Promise((resolve,reject)=>{
        return this.$store.dispatch('users/getAll',{pagination,filter}).then((res) => {
          console.log(res)
          this.users=res
          this.loadingTable = false
          resolve()
        }).catch(() => {
          this.loadingTable = false
          reject()
        })
      })


    }
  },
  created(){
   this.request({pagination: this.pagination, filter: this.filter})
  },
  computed:{
    pagination: {
      get() {
        return this.$store.state.users.paginate
      },
      set(valUse) {

      }
    },
  }
}
</script>
